'use strict';

/**
 * @param {Egg.Application} app - egg application
 */
module.exports = app => {
  const { router, controller } = app;
  router.get('/', controller.home.index);
  const stoken = app.middleware.stoken();
  router.get('/api/m/stoken', stoken, controller.stoken.getToken);
  router.post('/api/m/checkToken', controller.stoken.checkToken);
  router.delete('/api/m/checkToken', controller.stoken.checkToken);
  router.get(/^\/api\/m*/, controller.request.index);
  router.post(/^\/api\/m*/, controller.request.index);
  router.delete(/^\/api\/m*/, controller.request.index);
};
